> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.elacity.ai/llms.txt.
> For full documentation content, see https://docs.elacity.ai/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.elacity.ai/_mcp/server.

# Bulk create access grants

POST /api/access-grants/bulk
Content-Type: application/json

Create multiple access grants in one request while skipping duplicates

Reference: https://docs.elacity.ai/api-reference/elacity-prm-api/access-grants/access-grants-bulk-grant

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: openapi
  version: 1.0.0
paths:
  /access-grants/bulk:
    post:
      operationId: access-grants-bulk-grant
      summary: Bulk create access grants
      description: Create multiple access grants in one request while skipping duplicates
      tags:
        - subpackage_accessGrants
      parameters:
        - name: X-API-Key
          in: header
          description: >-
            API key supplied via the X-API-Key header. Takes precedence over
            bearerApiKey when both are present.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Access
                  Grants_accessGrants.bulkGrant_Response_200
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                orgSlug:
                  type: string
                grants:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/AccessGrantsBulkPostRequestBodyContentApplicationJsonSchemaGrantsItems
              required:
                - orgSlug
                - grants
servers:
  - url: /api
components:
  schemas:
    AccessGrantsBulkPostRequestBodyContentApplicationJsonSchemaGrantsItemsResourceType:
      type: string
      enum:
        - fleet
        - registry
        - environment
      title: >-
        AccessGrantsBulkPostRequestBodyContentApplicationJsonSchemaGrantsItemsResourceType
    AccessGrantsBulkPostRequestBodyContentApplicationJsonSchemaGrantsItems:
      type: object
      properties:
        userId:
          type: string
        resourceType:
          $ref: >-
            #/components/schemas/AccessGrantsBulkPostRequestBodyContentApplicationJsonSchemaGrantsItemsResourceType
        resourceId:
          type: string
      required:
        - userId
        - resourceType
        - resourceId
      title: AccessGrantsBulkPostRequestBodyContentApplicationJsonSchemaGrantsItems
    Access Grants_accessGrants.bulkGrant_Response_200:
      oneOf:
        - description: Any type
        - description: Any type
      title: Access Grants_accessGrants.bulkGrant_Response_200
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: X-API-Key
      description: >-
        API key supplied via the X-API-Key header. Takes precedence over
        bearerApiKey when both are present.
    bearerApiKey:
      type: http
      scheme: bearer
      description: >-
        Same organization API key supplied as a Bearer token in the
        Authorization header (Authorization: Bearer <key>). Compatible with
        OpenAI-SDK-standard clients. Accepted by all authenticated endpoints; if
        both X-API-Key and Authorization: Bearer are present, X-API-Key wins.

```

## SDK Code Examples

```python
import requests

url = "https://api/access-grants/bulk"

payload = {
    "orgSlug": "string",
    "grants": [
        {
            "userId": "string",
            "resourceType": "fleet",
            "resourceId": "string"
        }
    ]
}
headers = {
    "X-API-Key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api/access-grants/bulk';
const options = {
  method: 'POST',
  headers: {'X-API-Key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"orgSlug":"string","grants":[{"userId":"string","resourceType":"fleet","resourceId":"string"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api/access-grants/bulk"

	payload := strings.NewReader("{\n  \"orgSlug\": \"string\",\n  \"grants\": [\n    {\n      \"userId\": \"string\",\n      \"resourceType\": \"fleet\",\n      \"resourceId\": \"string\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-API-Key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api/access-grants/bulk")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"orgSlug\": \"string\",\n  \"grants\": [\n    {\n      \"userId\": \"string\",\n      \"resourceType\": \"fleet\",\n      \"resourceId\": \"string\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api/access-grants/bulk")
  .header("X-API-Key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"orgSlug\": \"string\",\n  \"grants\": [\n    {\n      \"userId\": \"string\",\n      \"resourceType\": \"fleet\",\n      \"resourceId\": \"string\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api/access-grants/bulk', [
  'body' => '{
  "orgSlug": "string",
  "grants": [
    {
      "userId": "string",
      "resourceType": "fleet",
      "resourceId": "string"
    }
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-API-Key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api/access-grants/bulk");
var request = new RestRequest(Method.POST);
request.AddHeader("X-API-Key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"orgSlug\": \"string\",\n  \"grants\": [\n    {\n      \"userId\": \"string\",\n      \"resourceType\": \"fleet\",\n      \"resourceId\": \"string\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-API-Key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "orgSlug": "string",
  "grants": [
    [
      "userId": "string",
      "resourceType": "fleet",
      "resourceId": "string"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api/access-grants/bulk")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```